let deferPromise=require("./defer")
/**
 * 
 * @param {{val:any}} obj 
 * @param {Object} action
 * @param {function():Promise} action.cb 
 * @param {function():Promise} action.error 
 * @return {{  unlock:function():Boolean,lock:function():Boolean,val:val }}
 */
function lockVar(obj,action) {//处理val
    let val=obj.val;
    let lockStat=deferPromise();
    let lock=(params)=> {
         Object.defineProperty(obj,"val",{
             get:function () {
                 return val;
             },
             set:function (params) {
                 action.error&&action.error(params);
                 //有错误
             }
         }); 
    }
    const unlock=(params)=> {
        Object.defineProperty(obj,"val",{
            get:function (params) {
                return val;
            },
            value:val
        }); 
   }
   //等待变量解锁执行函数
   lockStat.promise.then(
    action.cb
   );// 变量读取完毕 执行下个函数
};
// module.exports =lockVar;